format ELF64

macro print_sum [numbers] {
  common
  local ..fmt, ..code
        jmp      ..code
  ..fmt db       'Sum is: %Ld', 0Dh, 0Ah, 00h
  ..code:
        mov      rcx, ..fmt
        xor      rdx, rdx
  forward
        add      rdx, numbers
  common
        call     printf
}

section '.text' executable
public main
extrn printf
main:
        mov     rbp, rsp
        sub     rsp, 32
        and     rsp, -16
        print_sum 10, 10
        print_sum 1, -2, 3, -4
        print_sum 1, 2, 3, 4, 5, 6, 7, 8, 9
        mov     rsp, rbp
        xor     rax, rax
        ret
