format ELF64

macro persons_list [names, professions] {
  common
  local ..fmt, ..code
          jmp      ..code
  ..fmt   db       '%s is a %s', 0Dh, 0Ah, 00h
  ..code:
  forward
  local ..name, ..prof, ..continue
          jmp      ..continue
  ..name  db       names, 00h
  ..prof  db       professions, 00h
  ..continue:
          mov      rcx, ..fmt
          mov      rdx, ..name
          mov      r8, ..prof
          call     printf
}

section '.text' executable
public main
extrn printf
main:
          mov     rbp, rsp
          sub     rsp, 32
          and     rsp, -16
          persons_list 'Aly Baba', 'programmer'
          persons_list 'Aly', 'Free Pascal programmer', 'Juno', 'movie actrice', 'Yoko', 'chemical engineer'
          mov     rsp, rbp
          xor     rax, rax
          ret
